import QtQml 2.12
import QtQuick 2.12
import QtQuick.Controls 2.4
import QtQuick.Controls.Material 2.4
import QtQuick.Window 2.12
import QtQuick.Layouts 1.12

import MultiTouch 1.0

ColumnLayout {
    id: root

    GesturePolicySettings {
        id: gesturePolicySettings
    }
    Item {
        implicitWidth: 700
        implicitHeight: 700

        Rectangle {
            parent: flickable.contentItem
            anchors.fill: parent
            color: "#B0BEC5"
            z: -1
        }
        Flickable {
            id: flickable

            clip: true
            anchors.fill: parent
            contentWidth: 900
            contentHeight: 1000

            TextBox {
                x: 0
                y: 0
                description: "DragHandler"

                DragHandler {}
            }

            TextBox {
                x: 100
                y: 0
                description: "TapHandler"
                pressed: tapHandler1.pressed

                TapHandler {
                    id: tapHandler1

                    gesturePolicy: gesturePolicySettings.gesturePolicy()
                }
            }
            TextBox {
                x: 200
                y: 0
                description: "TapHandler\nDragHandler"
                pressed: tapHandler2.pressed

                TapHandler {
                    id: tapHandler2

                    gesturePolicy: gesturePolicySettings.gesturePolicy()
                }
                DragHandler {}
            }
            TextBox {
                x: 300
                y: 0
                description: "DragHandler\nTapHandler"
                pressed: tapHandler3.pressed

                TapHandler {
                    id: tapHandler3

                    gesturePolicy: gesturePolicySettings.gesturePolicy()
                }
                DragHandler {}
            }
            TextBox {
                x: 400
                y: 0
                description: "DragHandler"

                DragHandler {}
                TextBox {
                    x: (parent.width - width) / 2
                    y: 60
                    large: false
                    description: "TapHandler"
                    pressed: tapHandler4.pressed

                    TapHandler {
                        id: tapHandler4

                        gesturePolicy: gesturePolicySettings.gesturePolicy()
                    }
                }
            }
            TextBox {
                x: 500
                y: 0
                description: "TapHandler"
                pressed: tapHandler5.pressed

                TapHandler {
                    id: tapHandler5

                    gesturePolicy: gesturePolicySettings.gesturePolicy()
                }
                TextBox {
                    x: (parent.width - width) / 2
                    y: 60
                    large: false
                    description: "DragHandler"

                    DragHandler {}
                }
            }
            TextBox {
                x: 600
                y: 0
                description: "MouseArea"
                pressed: mouseArea.pressed

                MouseArea {
                    id: mouseArea

                    anchors.fill: parent
                    drag.target: parent
                }
            }
            Rectangle {
                id: circle

                x: 100
                y: 100
                width: 90
                height: width
                color: "#8BC34A"
                radius: width / 2

                Text {
                    anchors.centerIn: parent
                    text: qsTr("Flick me with velocity: %1").arg(circleDragHandler.centroid.velocity)
                }

                DragHandler {
                    id: circleDragHandler

                    onActiveChanged: {
                        if (!active) {
                            animation.restart(centroid.velocity)
                        }
                    }
                }
                MomentumAnimation {
                    id: animation
                    target: circle
                }
            }
        }
    }
}
