import QtQuick 2.12

ParallelAnimation {
    id: root

    property Item target: null
    property int duration: 500
    property vector2d velocity: Qt.vector2d(0,0)

    function restart(velocity) {
        stop();
        root.velocity = velocity;
        start();
    }

    NumberAnimation {
        target: root.target
        property: "x"
        to: target.x + (velocity.x / duration * 100000)
        duration: root.duration
        easing.type: Easing.OutQuad
    }
    NumberAnimation {
        target: root.target
        property: "y"
        to: target.y + (velocity.y / duration * 100000)
        duration: root.duration
        easing.type: Easing.OutQuad
    }
}
