import QtQml 2.12
import QtQuick 2.12
import QtQuick.Controls 2.4
import QtQuick.Controls.Material 2.4
import QtQuick.Window 2.12
import QtQuick.Layouts 1.12

import MultiTouch 1.0

ColumnLayout {
    RowLayout {
        Label {
            Layout.fillWidth: true

            text: qsTr("Maximum touch points: %1").arg(TouchDeviceInfo.maximumTouchPoints)
        }
        Label {
            Layout.fillWidth: true

            text: qsTr("Capabilities:\n  %1").arg(TouchDeviceInfo.capabilities.join("\n  "))
        }
    }
    Item {
        Layout.fillWidth: true
        Layout.fillHeight: true

        //NOTE it is impossible to create mutliple PointHandlers with Repeater, Instantiator, or Javascript (createObject, createQmlObject) (see: QTBUG-71427)
        VisualPointHandler {
            enabled: TouchDeviceInfo.maximumTouchPoints > 0
        }
        VisualPointHandler {
            enabled: TouchDeviceInfo.maximumTouchPoints > 1
        }
        VisualPointHandler {
            enabled: TouchDeviceInfo.maximumTouchPoints > 2
        }
        VisualPointHandler {
            enabled: TouchDeviceInfo.maximumTouchPoints > 3
        }
        VisualPointHandler {
            enabled: TouchDeviceInfo.maximumTouchPoints > 4
        }
        VisualPointHandler {
            enabled: TouchDeviceInfo.maximumTouchPoints > 5
        }
        VisualPointHandler {
            enabled: TouchDeviceInfo.maximumTouchPoints > 6
        }
        VisualPointHandler {
            enabled: TouchDeviceInfo.maximumTouchPoints > 7
        }
        VisualPointHandler {
            enabled: TouchDeviceInfo.maximumTouchPoints > 8
        }
        VisualPointHandler {
            enabled: TouchDeviceInfo.maximumTouchPoints > 9
        }
    }

    //TODO test trackpad system gesture if tapping with 3 fingers (It open system menu now...)
}
