import QtQml 2.12
import QtQuick 2.12
import QtQuick.Controls 2.4
import QtQuick.Controls.Material 2.4
import QtQuick.Window 2.12
import QtQuick.Layouts 1.12

import MultiTouch 1.0

ColumnLayout {
    id: root

    RowLayout {
        RadioButton {
            id: enablePinchRadioButton

            text: qsTr("Pinch")
            checked: true
        }
        RadioButton {
            id: enableDragRadioButton

            text: qsTr("Drag")
        }
    }

    Rectangle {
        Layout.fillWidth: parent
        Layout.fillHeight: parent

        implicitWidth: 700
        implicitHeight: 700
        color: "#B0BEC5"
        clip: true

        TransformedElement {
            x: 50
            y: 50
            width: parent.width - 200
            height: parent.height - 200
            minimumScale: 0.4
            maximumScale: 2
            enablePinch: enablePinchRadioButton.checked

            TransformedElement {
                x: 50
                y: 50
                width: 500
                height: 400
                minimumScale: 0.4
                maximumScale: 2
                rotation: -30
                transformOrigin: Item.Top
                enablePinch: enablePinchRadioButton.checked

                TransformedElement {
                    x: 50
                    y: 50
                    width: 400
                    height: 600
                    minimumScale: 0.4
                    maximumScale: 2
                    minimumPointCount: 3
                    rotation: 70
                    enablePinch: enablePinchRadioButton.checked
                }
            }
        }
    }
}
