import QtQml 2.12
import QtQuick 2.12
import QtQuick.Controls 2.4
import QtQuick.Controls.Material 2.4
import QtQuick.Window 2.12
import QtQuick.Layouts 1.12

import MultiTouch 1.0

ColumnLayout {
    id: root

    GesturePolicySettings {
        id: gesturePolicySettings
    }
    Rectangle {
        implicitWidth: childrenRect.width
        implicitHeight: childrenRect.height
        color: "lightGrey"

        VisualTapHandler {
            id: handler1

            gesturePolicy: gesturePolicySettings.gesturePolicy()
            color: "#FF9800"
        }
        VisualMouseArea {
            id: mouseArea1

            anchors { right: handler2.left; rightMargin: -70; bottom: handler2.bottom }
            color: "#9C27B0"
        }
        VisualTapHandler {
            id: handler2

            anchors { left: handler1.right; top: handler1.bottom; leftMargin: -70; topMargin: -70 }
            gesturePolicy: gesturePolicySettings.gesturePolicy()
            color: "#CDDC39"
        }
        VisualMouseArea {
            id: mouseArea2

            anchors { left: handler1.right; leftMargin: -70; top: handler1.top; topMargin: 20 }
            color: "#2196F3"
        }
        Button {
            id: button

            anchors { left: handler2.right }
            implicitWidth: 700
            implicitHeight: 700
            text: "This is button!"
            onClicked: console.debug("onClicked", button)

            VisualTapHandler {
                id: handler3

                gesturePolicy: gesturePolicySettings.gesturePolicy()
                color: "#FF9800"
            }
            VisualMouseArea {
                id: mouseArea3

                anchors.bottom: parent.bottom
                color: "#2196F3"
            }
        }
    }
}
