#include "TouchDeviceInfo.h"

#include <QDebug>
#include <QTouchDevice>

TouchDeviceInfo::TouchDeviceInfo(QObject* parent)
    : QObject(parent)
    , m_maximumTouchPoints(0) {
    const auto touchDevices = QTouchDevice::devices();
    qDebug() << "Touch device count:" << touchDevices.count();
    if (!touchDevices.isEmpty()) {
        const auto touchDevice = touchDevices.first();
        m_maximumTouchPoints = touchDevice->maximumTouchPoints();
        const auto capabilities = touchDevice->capabilities();
        if (capabilities & QTouchDevice::Position) {
            m_capabilities << "Position";
        }
        if (capabilities & QTouchDevice::Area) {
            m_capabilities << "Area";
        }
        if (capabilities & QTouchDevice::Pressure) {
            m_capabilities << "Pressure";
        }
        if (capabilities & QTouchDevice::Velocity) {
            m_capabilities << "Velocity";
        }
        if (capabilities & QTouchDevice::RawPositions) {
            m_capabilities << "RawPositions";
        }
        if (capabilities & QTouchDevice::NormalizedPosition) {
            m_capabilities << "NormalizedPosition";
        }
        if (capabilities & QTouchDevice::MouseEmulation) {
            m_capabilities << "MouseEmulation";
        }
    }
}

int TouchDeviceInfo::maximumTouchPoints() const { return m_maximumTouchPoints; }

QStringList TouchDeviceInfo::capabilities() const { return m_capabilities; }
