import QtQuick 2.12
import QtQuick.Controls 2.4
import QtQuick.Layouts 1.12

PointHandler {
    id: root

    //NOTE it is impossible to show multiple of point handlers if touch was started in the same moment (see: QTBUG-71431)

    target: Item {
        parent: root.parent //TODO
        visible: root.active
        x: root.point.position.x - width / 2
        y: root.point.position.y - height / 2
        width: 140
        height: width

        Rectangle {
            id: marker

            anchors.fill: parent
            color: "orange"
            radius: width / 2
            opacity: 0.3
        }

        Popup {
            x: marker.width / 2
            y: -height
            modal: false
            closePolicy: Popup.NoAutoClose
            margins: 10
            visible: root.active
            enter: null
            exit: null

            GridLayout {
                id: detailsLayout

                anchors.fill: parent
                columns: 2

                Label {
                    text: qsTr("id:")
                }
                Label {
                    text: qsTr("%1").arg(root.point.id)
                }
                Label {
                    text: qsTr("ellipseDiameters:")
                }
                Label {
                    text: qsTr("%1").arg(root.point.ellipseDiameters)
                }
                Label {
                    text: qsTr("position:")
                }
                Label {
                    text: qsTr("%1").arg(root.point.position)
                }
                Label {
                    text: qsTr("pressPosition:")
                }
                Label {
                    text: qsTr("%1").arg(root.point.pressPosition)
                }
            }
        }
    }
    onActiveChanged: console.debug("Active changed", active)
}
