import QtQml 2.12
import QtQuick 2.12
import QtQuick.Controls 2.4
import QtQuick.Controls.Material 2.4
import QtQuick.Window 2.12
import QtQuick.Layouts 1.12

import MultiTouch 1.0

Item {
    id: root

    property alias gesturePolicy: tapHandler.gesturePolicy
    property alias color: background.color
    
    implicitWidth: detailsLayout.implicitWidth + 100
    implicitHeight: detailsLayout.implicitHeight + 100

    Rectangle {
        id: background

        anchors.fill: parent
        color: "red"
        opacity: 0.7
    }
    
    TapHandler {
        id: tapHandler
        
        readonly property bool longPressed: pressed && (timeHeld > longPressThreshold)
        
        onTapped: console.debug("onTapped", tapHandler)
        onSingleTapped: console.debug("onSingleTapped", tapHandler)
        onDoubleTapped: console.debug("onDoubleTapped", tapHandler)
        onLongPressed: console.debug("onLongPressed", tapHandler)
        onCanceled: console.debug("onCanceled", tapHandler)
    }
    
    GridLayout {
        id: detailsLayout

        anchors.centerIn: parent
        columns: 2
        
        Label {
            text: qsTr("ID:")
        }
        Label {
            text: qsTr("%1").arg(tapHandler)
        }
        Label {
            text: qsTr("active:")
        }
        Label {
            text: qsTr("%1").arg(tapHandler.active)
        }
        Label {
            text: qsTr("pressed:")
        }
        Label {
            text: qsTr("%1").arg(tapHandler.pressed)
        }
        Label {
            text: qsTr("long pressed:")
        }
        Label {
            text: qsTr("%1").arg(tapHandler.longPressed)
        }
        Label {
            text: qsTr("tapCount:")
        }
        Label {
            text: qsTr("%1").arg(tapHandler.tapCount)
        }
        Label {
            text: qsTr("long press threshold:")
        }
        Label {
            text: qsTr("%1").arg(tapHandler.longPressThreshold)
        }
        Label {
            text: qsTr("time held:")
        }
        Label {
            text: qsTr("%1").arg(tapHandler.timeHeld)
        }
        Label {
            text: qsTr("mouse double click interval:")
        }
        Label {
            text: qsTr("%1").arg(Qt.styleHints.mouseDoubleClickInterval)
        }
        Button {
            id: button

            text: qsTr("Button....................")
            onClicked: console.debug("onClicked", button)
        }
    }
}
