#include <QDebug>
#include <QGuiApplication>
#include <QQmlApplicationEngine>
#include <QWindow>

#include "TouchDeviceInfo.h"
#include <QLoggingCategory>

int main(int argc, char* argv[]) {
    QCoreApplication::setAttribute(Qt::AA_EnableHighDpiScaling);

#if 1
    qSetMessagePattern(
        "%{time process} %{if-debug}D%{endif}%{if-warning}W%{endif}%{if-critical}C%{endif}%{if-fatal}F%{endif}] "
        "%{category} %{function} - %{message}");
    QLoggingCategory::setFilterRules(
        "qt.quick.mouse=true\n"
        "qt.quick.mouse.target=true\n"
        "qt.quick.touch.target=true\n"
        "qt.quick.touch=true\n"
        "qt.quick.pointer.grab=true\n"
        "qt.quick.pointer.events=true\n"
        "qt.quick.handler.tap=true\n"
        "qt.qpa.input.events=true\n"
        "qt.qpa.input=true\n");
#endif

    QGuiApplication app(argc, argv);

    qmlRegisterSingletonType<TouchDeviceInfo>(
        "MultiTouch", 1, 0, "TouchDeviceInfo", [](QQmlEngine* engine, QJSEngine* scriptEngine) -> QObject* {
            Q_UNUSED(engine);
            Q_UNUSED(scriptEngine);
            return new TouchDeviceInfo();
        });

    QQmlApplicationEngine engine;
    engine.load(QUrl(QStringLiteral("qrc:/main.qml")));

    auto rootObjects = engine.rootObjects();
    if (rootObjects.isEmpty()) {
        return -1;
    }
    auto window = qobject_cast<QWindow*>(rootObjects.first());
    if (!window) {
        return -1;
    }

    return app.exec();
}
