import QtQml 2.12
import QtQuick 2.12
import QtQuick.Controls 2.4
import QtQuick.Controls.Material 2.4
import QtQuick.Window 2.12
import QtQuick.Layouts 1.12

import MultiTouch 1.0

ApplicationWindow {
    id: root

    Material.accent: "#2196F3"

    width: 800
    height: 600
    visible: true
    title: qsTr("CE-26 Multi-Touch Qt Prototyp")

    ColumnLayout {
        anchors.fill: parent

        TabBar {
            id: tabBar

            Layout.fillWidth: true

            TabButton {
                text: qsTr("Multiple PointHandler")
            }
            TabButton {
                text: qsTr("TapHandler")
            }
            TabButton {
                text: qsTr("DragHandler")
            }
            TabButton {
                text: qsTr("PinchHandler")
            }
        }
        StackLayout {
            Layout.fillWidth: true
            Layout.maximumWidth: root.width

            currentIndex: tabBar.currentIndex

            MultiplePointHandlerView {}
            TapHandlerView {}
            DragHandlerView {}
            PinchHandlerView {}
        }
    }
}
